/*!
	\file resources.cpp

	\brief cpp-Datei der resources
	\author Christian Roesch
	\date 21.6.2010

	Erklaerung	
*/

#include "resources.h"
#include "globals.h"

#include <fstream>

void LoadAnimation(
	HTEXTURE& tex,
	hgeAnimation*& anim, 
	const char* pcFileName,
	int SizeX,
	int SizeY,
	int Frames )
{
	tex=g_hge->Texture_Load(pcFileName);
	anim= new hgeAnimation(tex, Frames, 12.5f, 0, 0, SizeX, SizeY );
	anim->SetColor(0xFFFFFFFF);
	anim->SetHotSpot(SizeX/2,SizeY/2);
}

void LoadObject( ObjectTextures ID, const char* pcFileName, int Frames )
{
	LoadAnimation(
		texObj[ ID ],
		sprObj[ ID ],
		pcFileName,
		32,
		32,
		Frames );
}

void LoadResource()
{
	// Load sound and texture
	/*sndEnergy=g_hge->Effect_Load("data/energy.ogg");
	sndPacEaten=g_hge->Effect_Load("data/paceaten.wav");
	sndFoodEaten=g_hge->Effect_Load("data/food.wav");
	sndDead=g_hge->Effect_Load("data/dead.wav");
	sndNextLevel=g_hge->Effect_Load("data/nextlevel.wav");

	musGame = g_hge->Music_Load("data/stardust.xm");*/

	// Create and set up a sprites
	for( int i= 0; i < 256; ++i )
	{
		char pcName[]= "data/000tiles.png";
		pcName[ 5 ]= '0' + (i / 100 ) % 10;
		pcName[ 6 ]= '0' + (i / 10 ) % 10;
		pcName[ 7 ]= '0' + (i / 1 ) % 10;

#ifdef DEBUGACTIVE
		if( true )
		{
#else
		std::ifstream ifs( pcName );
		if( ifs.is_open() || g_EditorEnabled )
		{
			ifs.close();
#endif
			texTile[ i ]=g_hge->Texture_Load(pcName);
			sprTile[ i ]= new hgeSprite(texTile[ i ], 0, 0, 32, 32 );
			sprTile[ i ]->SetColor(0xFFFFFFFF);
			sprTile[ i ]->SetHotSpot(16,16);
		}
		else
		{
			texTile[ i ]= 0;
			sprTile[ i ]= new hgeSprite(texTile[ i ], 0, 0, 32, 32 );
			sprTile[ i ]->SetColor(0xFFFFFFFF);
			sprTile[ i ]->SetHotSpot(16,16);
		}
	}
	/*LoadAnimation(
		texTiles,
		sprTiles,
		
		32,
		32,
		256 );*/

	LoadObject( OT_PLAYER, "data/player.png", 1 );
	LoadObject( OT_COOP, "data/enemy.png", 1 );
	LoadObject( OT_MOVER, "data/mover.png", 1 );
	LoadObject( OT_MOVER_EAST, "data/movere.png", 1 );
	LoadObject( OT_MOVER_SOUTH, "data/movers.png", 1 );
	LoadObject( OT_MOVER_WEST, "data/moverw.png", 1 );
	LoadObject( OT_MOVER_NORTH, "data/movern.png", 1 );
	LoadObject( OT_TALKER, "data/talker.png", 1 );
	LoadObject( OT_START, "data/start.png", 1 );
	LoadObject( OT_SELECT, "data/select.png", 1 );

	texCursor=g_hge->Texture_Load("data/cursor.png");
	sprCursor= new hgeSprite(texCursor, 0, 0, 32, 32 );
	sprCursor->SetColor(0xFFFFFFFF);
	sprCursor->SetHotSpot(1,1);

	texTextBack=g_hge->Texture_Load("data/textback.png");
	sprTextBack= new hgeSprite(texTextBack, 0, 0, 128, 32 );
	sprTextBack->SetColor(0xFFFFFFFF);
	sprTextBack->SetHotSpot(0,0);

	texEditBack=g_hge->Texture_Load("data/editback.png");
	sprEditBack= new hgeSprite(texEditBack, 0, 0, 512, 512 );
	sprEditBack->SetColor(0xFFFFFFFF);
	sprEditBack->SetHotSpot(0,0);

	texMsgBack=g_hge->Texture_Load("data/msgback.png");
	sprMsgBack= new hgeSprite(texMsgBack, 0, 0, 512, 512 );
	sprMsgBack->SetColor(0xFFFFFFFF);
	sprMsgBack->SetHotSpot(0,0);

	extern HTEXTURE		texTextBack;
	extern hgeSprite*	sprTextBack;

	// Load a font
	fnt= new hgeFont("data/font1.fnt");
	fnt->SetColor(0xFFFFFFFF);
}
void FreeResource()
{
	//... immer noch zu faul...
}

HTEXTURE			texTile[256];
hgeSprite*			sprTile[256];

HTEXTURE		texObj[ OT_COUNT ];
hgeAnimation*	sprObj[ OT_COUNT ];

HTEXTURE		texCursor;
hgeSprite*		sprCursor;

HTEXTURE		texTextBack;
hgeSprite*		sprTextBack;
HTEXTURE		texEditBack;
hgeSprite*		sprEditBack;
HTEXTURE		texMsgBack;
hgeSprite*		sprMsgBack;


hgeFont*			fnt;

/*HEFFECT			sndEnergy;
HEFFECT				sndPacEaten;
HEFFECT				sndFoodEaten;
HEFFECT				sndDead;
HEFFECT				sndNextLevel;

HMUSIC				musGame;*/

//	EOF: resources.cpp
